#! /usr/bin/perl -w
use strict;
use LWP::UserAgent;
use HTTP::Request::Common qw(POST);
# --------------------------------------------------------------------------------
# Script to extract weekly produced energy from: http://192.168.xxx.xxx/appliances/interval_logs
#
# Usage:  parseappliances.pl xmlfile
# --------------------------------------------------------------------------------
#	this is really ugly,
#	Synology people: please fix perl XML libraries in DSM 4.1!!!
BEGIN {
  require XML::Parser::Expat;
    my $saved_version=$XML::Parser::Expat::VERSION;
      $XML::Parser::Expat::VERSION= '2.36';
        require XML::Parser;
          $XML::Parser::Expat::VERSION= $saved_version;
          }
#           use XML::Parser;
           use LWP::Simple;

# --------------------------------------------------------------------------------------------
#  read command line parameters
my $xmlfile       = $ARGV[0];                    		# the file to parse
my $outfile_dir   = $ARGV[1];                    		# location of outputfile 
my $device_name   = $ARGV[2];                    		# name of device to read
my $pvlog_enabled = $ARGV[3];                           # will PVoutput be updated ?
my $PV_API_key    = $ARGV[4];                    		# API-key for PVoutput
my $PV_sid		  = $ARGV[5];                    		# sid for PVoutput
# --------------------------------------------------------------------------------------------

#start of script
# initialize parser object and parse the string
	my ( $periodend, $producedfound,@data,$log_date,$current_key,$tree,@new);
	my ($last_written, $last_written_date, $dayoutput,$last_written_hour);
	my (@pvlog, $url, $content, $pvurl,$separator);
	my ( @xmlrecord);
	  
	if (substr($outfile_dir,(length($outfile_dir)-1),1) ne '/')
	   {$outfile_dir = $outfile_dir."/"} # adding final /
  
	my $parser = XML::Parser->new();
	$separator=',';
	$periodend=0;
	$producedfound=0;
	$parser->setHandlers( Start => \&handle_start,
				  Char  => \&handle_char,
				  End   => \&handle_end,     );
																				 

	# Parse the file, calling the handlers in the mean time.
	$tree  = $parser->parsefile( $xmlfile );
 exit;

# end of script
# --------------------------------------------------------------------------------------------
# below the subs
#----------------------------------------------------------------
sub getpvlog
#----------------------------------------------------------------
{# retrieve most recent standings from PVoutput server
  $pvurl = "http://pvoutput.org/service/r2/";
  $url = $pvurl."getoutput.jsp?key=".$PV_API_key."&sid=".$PV_sid;
  $content = get $url;
  die "Couldn't get $url" unless defined $content;
  @pvlog = split /,/,$content;
  if (not @pvlog) { $pvlog[0] == '20090101';} #less than initial value for other dates
}

#----------------------------------------------------------------
sub updatepv
#----------------------------------------------------------------
{# update pvoutput with new dayvalues
    my ($day,$value,$peaktime, $peakval) = @_;
	my ($xml,$ua,$response);
	$value = int($value + $value/abs($value*2));
	if ($peakval > 0) # no maximum value
	    {$peakval = int($peakval + $peakval/abs($peakval*2));}
	$pvurl = "http://pvoutput.org/service/r2/";
	$url = $pvurl."addoutput.jsp";
		
     $url = $pvurl."addoutput.jsp";
	 $response = `curl -d "data=$day,$value,,$peakval,$peaktime" -H "X-Pvoutput-Apikey:$PV_API_key" -H "X-Pvoutput-SystemId:$PV_sid" $url`;
     my $temp = $response
#     if ($response->is_success) 
#	   { print $response->decoded_content; }  # or whatever
}

#----------------------------------------------------------------
sub makedate
#----------------------------------------------------------------
{
my ( $result,$year,$month,$day,$hour,@items,$date );
my ( $sec, $min, $uur, $dag, $maand, $jaar_off, $wdag, $ydat, $isdst) = localtime;

	#print ("makedate from $log_date\n");
	$log_date =~ s/[-:T+]/ /g;
	@items = split /\s+/, $log_date ;
	$year = $items[0];
	$month = sprintf("%02d",$items[1]);
	$date = sprintf("%02d",$items[2]);

	# stretch is at GMT!
	if ($isdst)  	
	   {$hour   = sprintf("%02d",$items[3]+2);}
	else
	   {$hour   = sprintf("%02d",$items[3]+1);}
	return ( $year." ".$month." ".$date." ".$hour." ");
}

#----------------------------------------------------------------
sub handle_char
#----------------------------------------------------------------
{
  my ($p, $text, %attrs ) = @_;

    if ( $periodend == 0 ) 
	    {
		if ( $current_key eq 'measurement' ) 
		   {my $date = makedate ;
			#printf("$text\n") ;
			push( @data, $date . $text ) ;
		   }
	    $current_key="";
        }
    if ( $producedfound == 0 ) 
	{	if ( $text eq 'electricity_produced' ) 
		{   $producedfound=1;
		    $periodend=0;
	    }
    }

}

#----------------------------------------------------------------
sub handle_end
#----------------------------------------------------------------
{
  my ($p, $elmt ) = @_;
  if ( $elmt eq 'period' ) 
     {#printf("Period end found\n");
	  $periodend=1;
     }
	 
if ($periodend)
    { # process read records
     @new = sort  @data ;	 
	 if ($pvlog_enabled) 
	    {getpvlog();}
     makefile();
    }
}

#----------------------------------------------------------------
sub handle_start()
#----------------------------------------------------------------
{
  my ($p, $elmt, %attrs ) = @_;
  $current_key = $elmt ;
	# get the log_date attribute
	if ( $elmt eq 'measurement' ) 
	   {
		if( %attrs ) 
			{while( my( $key, $value ) = each( %attrs )) 
				{if ( $key eq 'log_date' ) 
					{$log_date = $value ;}
		        }
			}
		}
}

#----------------------------------------------------------------
sub oldday
#----------------------------------------------------------------
{ # reading new day, reset daytotal
  my ($last_written_date, $prvday, $peakval, $peaktime,$outfile_hours ) = @_;
  my ($outfile_days,$temp, $dayline);


# if ($last_written_date lt $prvday)
	{ # previous day has not been written to file
	 $outfile_days  = $outfile_dir."logdays_".substr($prvday,0,4)."-".substr($prvday,4,2).".csv";
	 if ($last_written_date == "20100101") #last written day unknown
		  { #read file for this date
		  $temp = `tail -1 $outfile_days`;
		  my @temp = split /$separator/,$temp ;
		  if  ($temp[0]) 
			{#already values in file
			 $last_written_date = $temp[0];
			 $last_written_date =~ s/-//g;
			}
		} 
	}
if ($last_written_date lt $prvday)
	{open  (DAYFILE , "+>>$outfile_days") ||  die "open dayfile:$!";
	 $dayline = substr($prvday,0,4)."-".substr($prvday,4,2)."-".substr($prvday,6,2).$separator.$dayoutput."\r\n" ;
	 print (DAYFILE $dayline);
	 close (DAYFILE);
	 $last_written_date = $prvday;
	}   
if (($pvlog_enabled) && ($pvlog[0] <= $prvday)  && $dayoutput > 0)
   {updatepv($prvday,$dayoutput,$peaktime,$peakval);}

# check what is maximum value for hourrecord in new date
$outfile_hours = $outfile_dir."loghours_".$xmlrecord[0]."-".$xmlrecord[1]."-".$xmlrecord[2].".csv";
$temp = `tail -1 $outfile_hours`;
	my @temp = split /$separator/,$temp ;
	if  ($temp[0]) 
	    {#already values in file
         $last_written_hour = $temp[0].$temp[1];
		 $last_written_hour =~ s/-//g;
		}


}

#----------------------------------------------------------------
sub makefile()
#----------------------------------------------------------------
{
my ($temp,$xmltime,$xmldate,$xmlvalue, $hourfile_open );
my ($last_written_date, $prvday, $peakval, $peaktime,$outfile_hours);
# initial values
$peaktime = '00:00';
$peakval  = '0';
$last_written_hour = "2010010100:00";
$last_written_date = "20100101";
$dayoutput=0;

$prvday = $new[0];
$prvday =~ s/ //g;
$prvday = substr($prvday,0,6).sprintf("%02d",(substr($prvday,6,2)-1));

foreach (@new)
{
	# make an output line of the data
	@xmlrecord = split /\s+/,$_ ;
	$xmldate  = $xmlrecord[0].$xmlrecord[1].$xmlrecord[2];
	$xmltime  = $xmlrecord[3].":00";
	$xmlvalue = $xmlrecord[4];
	if ($prvday lt $xmldate)
		{# new day, write dayrecord and reset daytotals
		 oldday($last_written_date, $prvday, $peakval, $peaktime,$outfile_hours,$last_written_hour);		
		 $dayoutput= 0;
		 $peakval  = 0;
		 $peaktime = 0;
		 $hourfile_open = 0;
		 $prvday   = $xmldate;
	   }
	$dayoutput = $dayoutput + $xmlvalue;
	if ($peakval < $xmlvalue) 
		   { # new maximum
			$peakval  = $xmlvalue;
			$peaktime = $xmltime;
		   }				
	if ($xmldate.$xmltime gt $last_written_hour)
	   { # need to write this entry ?
		my $line = $xmlrecord[0]."-".$xmlrecord[1]."-".$xmlrecord[2].$separator.$xmltime.$separator.$xmlvalue."\r\n" ;
		if (not $hourfile_open) 
			{$outfile_hours = $outfile_dir."loghours_".$xmlrecord[0]."-".$xmlrecord[1]."-".$xmlrecord[2].".csv";
			 open (HOURFILE, "+>>$outfile_hours") || die "open hourfile:$!";
			 $hourfile_open = 1;
			 }
		print (HOURFILE $line);
		$last_written_hour = $xmldate.$xmltime;
	   }	
}
if (($pvlog_enabled) && ($pvlog[0] <= $xmldate)  && $dayoutput > 0)
	{updatepv($xmldate,$dayoutput,$peaktime,$peakval);}
		
close (HOURFILE);
exit;
}
#----------------------------------------------------------------




